/*
 * xtags - print C-file's indexes
 *
 * Program zaliczeniowy
 * Autor: Micha Moskal (nr albumu 129934)
 *
 * $Id: keywords.c,v 1.2 2000/10/24 22:52:12 malekith Exp $
 */

#include "xtags.h"

static int cmp_str(const void *p1, const void *p2);

static char *c_keywords[] = {
"asm", "auto", "break", "case", "char", "const", "continue", "default",
"do", "double", "else", "enum", "extern", "float", "for", "goto", "if",
"inline", "int", "long", "register", "return", "short", "signed", "sizeof",
"static", "struct", "switch", "typedef", "union", "unsigned", "void",
"volatile", "while",
};

static char *cc_keywords[] = {
"asm", "auto", "bool", "break", "case", "catch", "char", "class",
"const", "const_cast", "continue", "default", "delete", "do", "double",
"dynamic_cast", "else", "enum", "extern", "false", "float", "for",
"friend", "goto", "if", "inline", "int", "long", "new", "operator",
"private", "protected", "public", "register", "reinterpret_cast",
"return", "short", "signed", "sizeof", "static", "static_cast", "struct",
"switch", "template", "this", "throw", "true", "try", "typedef",
"union", "unsigned", "virtual", "void", "volatile", "while", 
};

static int cmp_str(const void *p1, const void *p2)
{
	return strcmp(*(const char **)p1, *(const char **)p2);
}

int is_keyword(char *s)
{
	void *r;

	
	if (allow_plus_keywords)
		r = bsearch(&s, 
		    	    cc_keywords, 
			    sizeof(cc_keywords) / sizeof(cc_keywords[0]),
			    sizeof(cc_keywords[0]), 
			    cmp_str);
	else
		r = bsearch(&s, 
		    	    c_keywords, 
			    sizeof(c_keywords) / sizeof(c_keywords[0]),
			    sizeof(c_keywords[0]), 
			    cmp_str);
	return r != 0;
}
